//------------------------------------------------------------------------------
// shape_In.cpp -     
//     
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_rect_atd.h"
#include "shape_trian_atd.h"

//------------------------------------------------------------------------------

using namespace std;

namespace simple_shapes {

//------------------------------------------------------------------------------

  // ,   
  void In_shape_rectangle(shape* _this);     //     
  void Out_shape_rectangle(shape* _this);    //     
  double Area_shape_rectangle(shape* _this); //   
  void Destroy_shape_rectangle(shape* _this); //  

  // ,   
  void In_shape_triangle(shape* _this);     //     
  void Out_shape_triangle(shape* _this);    //     
  double Area_shape_triangle(shape* _this); //   
  void Destroy_shape_triangle(shape* _this); //  

//------------------------------------------------------------------------------

  //        
  shape* In()
  {
    shape *sp;
    cout << "Input key: for Rectangle is 1, for Triangle is 2, else break: ";
    int k;
    cin >> k;
    switch(k) {
    case 1:
      sp = &((new shape_rectangle)->base);

      sp->In = &In_shape_rectangle;
      sp->Out = &Out_shape_rectangle;
      sp->Area = &Area_shape_rectangle;
      sp->Destroy = &Destroy_shape_rectangle;

      sp->In(sp);
      return sp;
    case 2:
      sp = &((new shape_triangle)->base);

      sp->In = &In_shape_triangle;
      sp->Out = &Out_shape_triangle;
      sp->Area = &Area_shape_triangle;
      sp->Destroy = &Destroy_shape_triangle;

      sp->In(sp);
      return sp;
    default:
      return 0;
    }
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
