//------------------------------------------------------------------------------
// shape_rect_Constr.cpp -   , 
//      - 
//------------------------------------------------------------------------------

#include "shape_rect_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .
  void Init(rectangle &r, int x, int y);

  // ,   
  void In_shape_rectangle(shape* _this);     //     
  void Out_shape_rectangle(shape* _this);    //     
  double Area_shape_rectangle(shape* _this); //   
  void Destroy_shape_rectangle(shape* _this); //  

//------------------------------------------------------------------------------

  //    -    
  shape_rectangle *Create_shape_rectangle(int x, int y)
  {
    shape_rectangle *sr = new shape_rectangle;

    sr->base.In = &In_shape_rectangle;
    sr->base.Out = &Out_shape_rectangle;
    sr->base.Area = &Area_shape_rectangle;
    sr->base.Destroy = &Destroy_shape_rectangle;

    Init(sr->r, x, y);
    return sr;
  }

//------------------------------------------------------------------------------

  //     -    
  void Init_shape_rectangle(shape_rectangle &sr, int x, int y)
  {
    sr.base.In = &In_shape_rectangle;
    sr.base.Out = &Out_shape_rectangle;
    sr.base.Area = &Area_shape_rectangle;
    sr.base.Destroy = &Destroy_shape_rectangle;

    Init(sr.r, x, y);
  }

//------------------------------------------------------------------------------

  //   - 
  void Destroy_shape_rectangle(shape *_this)
  {
    delete (shape_rectangle*)_this;
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
