//------------------------------------------------------------------------------
// shape_rect_Constr.cpp -   , 
//      - 
//------------------------------------------------------------------------------

#include "shape_trian_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .
  void Init(triangle &t, int a, int b, int c);

  // ,   
  void In_shape_triangle(shape* _this);     //     
  void Out_shape_triangle(shape* _this);    //     
  double Area_shape_triangle(shape* _this); //   
  void Destroy_shape_triangle(shape* _this); //  

//------------------------------------------------------------------------------

  //    -    
  shape_triangle *Create_shape_triangle(int a, int b, int c)
  {
    shape_triangle *st = new shape_triangle;

    st->base.In = &In_shape_triangle;
    st->base.Out = &Out_shape_triangle;
    st->base.Area = &Area_shape_triangle;
    st->base.Destroy = &Destroy_shape_triangle;

    Init(st->t, a, b, c);
    return st;
  }

//------------------------------------------------------------------------------

  //     -    
  void Init_shape_triangle(shape_triangle &st, int a, int b, int c)
  {
    st.base.In = &In_shape_triangle;
    st.base.Out = &Out_shape_triangle;
    st.base.Area = &Area_shape_triangle;
    st.base.Destroy = &Destroy_shape_triangle;

    Init(st.t, a, b, c);
  }

//------------------------------------------------------------------------------

  //   - 
  void Destroy_shape_triangle(shape *_this)
  {
    delete (shape_triangle*)_this;
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
